<template>
  <v-navigation-drawer v-model="userSettings" temporary floating>
    <UserSettings height="100vh" width="100%" />
  </v-navigation-drawer>
  <v-toolbar density="compact" floating width="100%" title="Inbox">
    <template v-slot:prepend>
      <v-btn
        icon="mdi-account-edit"
        class="ma-0 pa-0"
        @click="userSettings = !userSettings"
      />
    </template>
  </v-toolbar>
  <AdminInterface v-if="nivelUsuario == 'administrador'" />
  <template v-else>
    <h1 v-if="props.chatList.length == 0">No Hay Chats</h1>
    <perfect-scrollbar :style="{ height: '90vh' }">
      <v-row class="ma-0 pa-0">
        <v-col
          v-for="chat in props.chatList"
          @click="select(chat)"
          class="ma-0 pa-1"
        >
          <v-btn
            width="90vw"
            :height="altura"
            min-height="100px"
            :color="getColor(chat.id)"
          >
            <v-icon :icon="chat.icon" class="mr-3" />
            {{ chat.previewMessage }}
          </v-btn>
        </v-col>
      </v-row>
    </perfect-scrollbar>
  </template>
</template>

<script setup lang="ts">
import { PropType, ref } from "vue";
import { Chat } from "../../data/models/Chat";
import AdminInterface from "./AdminInterface.vue";
import UserSettings from "./ChatList/UserSettings.vue";
import { Niveles } from "../../data/providers/ServerProvider";
import { backendCollector } from "../../data/collectors/backendCollector";
const props = defineProps({
  chatList: {
    required: true,
    type: Object as PropType<Chat[]>,
  },
  nivelUsuario: {
    required: true,
    type: Object as PropType<Niveles>,
  },
});
const userSettings = ref(false);
const altura = ref(`${Math.floor(85 / props.chatList.length)}vh`);
const emit = defineEmits<{
  (event: "selected", chat: Chat): void;
}>();

const chatIds = props.chatList.map((value) => value.id);
const chatsWithNewMsjs = await backendCollector.getChatsWithNewMessages(
  chatIds
);

function select(chat: Chat) {
  backendCollector.markAsRead(chat.id);
  emit("selected", chat);
}

function getColor(chatId: string) {
  if (
    !chatsWithNewMsjs.success ||
    chatsWithNewMsjs.data == null ||
    chatsWithNewMsjs.data.size == 0
  )
    return "";
  const nuevo = chatsWithNewMsjs.data.get(chatId);
  if (nuevo == undefined || nuevo == null) return "";
  switch (nuevo.prioridad) {
    case "normal":
      return "blue";
    case "alta":
      return "orange";
    case "emergencia":
      return "red";
  }
}
</script>

<style>
.v-application--wrap {
  min-height: 0vh !important;
}
</style>
